<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for OffLocationServiceCoreType StructType
 * @package Dg
 * @subpackage Structs
 */
class DgOffLocationServiceCoreType extends AbstractStructBase
{
    /**
     * The Type
     * Meta informations extracted from the WSDL
     * - use: required
     * @var string
     */
    public $Type;
    /**
     * The Address
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgOffLocationServiceCoreTypeAddress
     */
    public $Address;
    /**
     * Constructor method for OffLocationServiceCoreType
     * @uses DgOffLocationServiceCoreType::setType()
     * @uses DgOffLocationServiceCoreType::setAddress()
     * @param string $type
     * @param \dgsoft\StructType\DgOffLocationServiceCoreTypeAddress $address
     */
    public function __construct($type = null, \dgsoft\StructType\DgOffLocationServiceCoreTypeAddress $address = null)
    {
        $this
            ->setType($type)
            ->setAddress($address);
    }
    /**
     * Get Type value
     * @return string
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \dgsoft\EnumType\DgOffLocationServiceID_Type::valueIsValid()
     * @uses \dgsoft\EnumType\DgOffLocationServiceID_Type::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \dgsoft\StructType\DgOffLocationServiceCoreType
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\dgsoft\EnumType\DgOffLocationServiceID_Type::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $type, implode(', ', \dgsoft\EnumType\DgOffLocationServiceID_Type::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Get Address value
     * @return \dgsoft\StructType\DgOffLocationServiceCoreTypeAddress|null
     */
    public function getAddress()
    {
        return $this->Address;
    }
    /**
     * Set Address value
     * @param \dgsoft\StructType\DgOffLocationServiceCoreTypeAddress $address
     * @return \dgsoft\StructType\DgOffLocationServiceCoreType
     */
    public function setAddress(\dgsoft\StructType\DgOffLocationServiceCoreTypeAddress $address = null)
    {
        $this->Address = $address;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgOffLocationServiceCoreType
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
